improve licensing
[distro-setup] / switch-mail-host
index 22e6933509baa36b403f3118c91a9eeb65f1a72c..ce1bc86abc5cb3259de218c88c6b5604af653dab 100644 (file)
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-source /usr/local/lib/err
+set -e; . /usr/local/lib/bash-bear; set +e
 
 usage() {
   cat <<EOF
@@ -64,7 +64,7 @@ host2_only=false
 force=false
 force_arg=
 pull_reexec=false
-mp_args="-m /o,/a,/ar,/q,/qd,/qr"
+mp_args="-m /o,/a,/q,/qd,/qr"
 check_installed=false
 orig_args=("$@")
 if ! temp=$(getopt -l check-installed,force,pull-reexec,help afioh "$@"); then
@@ -126,7 +126,7 @@ if ! $force && { $check_installed || [[ $direction == push ]]; } ; then
       uninstalled-file-die $f
     fi
   done
-  if ! diff -q /a/bin/errhandle/err /usr/local/lib/err; then
+  if ! diff -q /a/bin/bash-bear-trap/bash-bear /usr/local/lib/bash-bear; then
     uninstalled-file-die err
   fi
   if $check_installed; then
@@ -161,14 +161,25 @@ case $direction in
           die "failed: $old_shell switch-mail-host --check-installed"
         fi
       fi
-      tmpf=$(mktemp)
-      m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
-      if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
+      tmpd=$(mktemp -d)
+      files=(
+        /usr/local/{bin/{unsaved-buffers{,.el},switch-mail-host},lib/bash-bear}
+      )
+      m scp -F $HOME/.ssh/confighome \
+        ${files[@]/#/root@$old_host:} $tmpd
+      diff=false
+      for f in ${files[@]}; do
+        if ! diff -q $tmpd/${f##*/} $f; then
+          m install -T $tmpd/${f##*/} $f
+          diff=true
+        fi
+      done
+      if $diff; then
         e "found different version on old_host=$old_hostname, reexecing"
-        m install -T $tmpf /usr/local/bin/switch-mail-host
         m /usr/local/bin/switch-mail-host --pull-reexec "${orig_args[@]}"
         exit 0
       fi
+      rm -r -- $tmpd
     fi
 
     f=/a/bin/bash_unpublished/source-state
@@ -203,7 +214,7 @@ esac
 if $mail_only; then
   mp_args="-m /o"
 elif $host2_only; then
-  mp_args="-m /a,/ar,/q,/qd,/qr"
+  mp_args="-m /a,/q,/qd,/qr"
 fi
 
 if ! $force; then
@@ -259,16 +270,7 @@ done
 # ensure these are unused before doing anything
 e "On $new_host: umounting /m and /o, checking emacs"
 {
-  cat <<'EOF'
-set -eE
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
-fi
-EOF
+  cat /usr/local/bin/unsaved-buffers
   if ! $host2_only; then
     cat <<EOF
 for dir in m o; do
@@ -282,19 +284,11 @@ EOF
 } | $new_shell bash -s
 
 if ! $mail_only; then
-  $old_shell bash -s <<'EOF'
-set -e
-if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
-  if [[ $bufs ]]; then
-    echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
-    exit 1
-  fi
-fi
+  cat /usr/local/bin/unsaved-buffers - <<'EOF' |  $old_shell bash -s
 
 # Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
 # But if emacs ignores the signal, let it live.
-killall -q emacs ||:
+pkill -xf 'emacs( --daemon| -f znc-all)' ||:
 
 if [[ -e /p/profanity-here ]]; then
   systemctl disable --now profanity
@@ -350,15 +344,18 @@ fi
 e Running main btrbk
 m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
 if (( ret )); then
-  bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
+  bang="███████"
   e $bang failed btrbk of /o. restoring old host as primary
-  m $old_shell /a/exe/primary-setup localhost
+  if ! m $old_shell /a/exe/primary-setup localhost; then
+    die "due to failed btrbk of /o, we tried to restore old host as primary, but then we failed at that too. To resolve: Fix & rerun switch-mail-host, or fix and rerun primary-setup localhost on old shell so you have a working mail server and then rerun switch-mail-host."
+  fi
+  e finished restoring old host as primary, now exiting $ret due to earlier failed btrbk of /o.
   exit $ret
 fi
 
 # new system is usable at this point
 blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
-printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
+printf "%s\n" "${blocks:0:${COLUMNS:-100}}"
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #